/**
 * Created by GoLand.
 * User: xzghua@gmail.com
 * Date: 2021/7/29
 * Time: 11:48 上午
 */
package main

func main() {
	//               1
	//              / \
	//             2   3
	//            / \  / \
	//

	// 第一行 1, 第二行 2,  第三行 4, 第四行 8,  第n行 2^(n-1)
	// 1 + 2 + 4 + 8 + 16

	pathInZigZagTree(29)
}

func pathInZigZagTree(label int) (res []int) {
	// 先得知道自己的所在的深度
	level := 1
	temp := label
	for {
		if temp>>1 == 0 {
			break
		}
		temp = temp >> 1
		level++
	}

	// 判断自己是在奇数层还是偶数层
	var isJ bool
	if level%2 != 0 {
		isJ = true
	}

	// 先假设都是正常排序的, 从左到右的这种
	// 然后放入到res里, 每个节点的父节点 等于 自己 或者自己-1 再除以2 (二叉树特性)
	for {
		res = append([]int{label}, res...)

		if level == 1 {
			break
		}

		if label%2 == 0 {
			label = label / 2
		} else {
			label = (label - 1) / 2
		}
		level--
	}

	// 定义一个 交叉点,因为每层都是偶数个(除了第一层),所以分界点有两个节点 比如  4,5,6,7 分界点就是 5 和 6
	// 根据找的点是奇数层还是偶数层决定应该切换哪些值(上面res 切片里的值)
	var left, right int
	for k, v := range res {
		// 第一个值和最后一个值不修改,第一个值是1 最后一个值是要找到值本身
		if k == len(res)-1 || k == 0 {
			continue
		}
		// 如果查找的值是奇数层,那么所有偶数层就需要对称转换
		// 如果查找的值是偶数层,那么所有奇数层就需要对称转换
		if (isJ && (k+1)%2 == 0) || (!isJ && (k+1)%2 != 0) {
			// 左对称节点是 2的层数次方 + 2的层数次方的一半
			left = (1 << k) + (1<<k)/2
			// 右节点等于 左节点减一
			right = left - 1
			// 那么对称的点就是  右节点 - 原值 + 左节点
			// 如果你好奇这个公式怎么出来的,可以试试 如果你要找的原值是左边   和 是右边  看看应该是多少
			res[k] = right - v + left
		}
	}

	return res
}
